<?php

namespace app\controllers;

use Yii;
use yii\web\Controller;
use yii\web\Response;
use app\models\ListModel;
use app\models\TaskModel;
use yii\web\NotFoundHttpException;

class TodoController extends Controller
{
   
    public function actionIndex()
    {
		$model = new ListModel();
		$token = $model->generate();
		return $this->redirect(['list', 'token' => $token]);
    }


    public function actionList($token)
    {
        /* @var $model ListModel */
        $model = ListModel::findByToken($token);
        if($model) {
            $token = $model->token;
            $tasks = $model->getTasks()->orderBy('id DESC')->all();
            return $this->render('index', [
                'token' => $token,
                'tasks' => $tasks,
                'listId' => $model->id
            ]);
        } else {
            throw new NotFoundHttpException('Список не найден');
        }

    }

    public function actionAddTask()
    {
        Yii::$app->response->format = Response::FORMAT_JSON;
        $listId = Yii::$app->request->post('list_id');
        $description = Yii::$app->request->post('description');
        $model = new TaskModel();
        $model->list_id = $listId;
        $model->description = $description;
        if ($model->save()) {
            return [
                'success' => true,
                'task_id' => $model->id,
                'date' => $model->date
            ];
        } else {
            return [
                'success' => false
            ];
        }
    }

    public function actionEditDescription()
    {
        $taskId = Yii::$app->request->post('task_id');
        $description = Yii::$app->request->post('description');
        $model = TaskModel::findOne($taskId);
        if ($model) {
            $model->description = $description;
            $model->save(false);
        }
    }

    public function actionFinishTask()
    {
        $taskId = Yii::$app->request->post('task_id');
        $model = TaskModel::findOne($taskId);
        if ($model) {
            $model->finished_at = time();
            $model->save(false);
        }
    }

    public function actionUnfinishTask()
    {
        $taskId = Yii::$app->request->post('task_id');
        $model = TaskModel::findOne($taskId);
        if ($model) {
            $model->finished_at = 0;
            $model->save(false);
        }
    }

    public function actionDeleteTask()
    {
        $taskId = Yii::$app->request->post('task_id');
        $model = TaskModel::findOne($taskId);
        if ($model) {
            $model->deleted = 1;
            $model->save(false);
        }
    }
   
  
}
