<?php

namespace app\models;

use Yii;
use yii\db\ActiveRecord;


/**
 * @property $id
 * @property $token
 */
class ListModel extends ActiveRecord
{
	
	public static function tableName()
	{
		return 'lists';
	}

	public function rules()
    {
        return [
            ['token', 'unique']
        ];
    }
	
	public function generate()
	{
	    // генерируем уникальный токен
	    do {
            $this->token = Yii::$app->security->generateRandomString(32);
        } while (!$this->validate());
	    $this->save();
	    return $this->token;
	}

	public static function findByToken($token)
    {
        return self::find()->where(['token' => $token])->limit(1)->one();
    }


    public function getTasks()
    {
        return $this->hasMany(TaskModel::className(), ['list_id' => 'id'])->andWhere('deleted = 0');
    }

}