<?php

namespace app\models;

use yii\db\ActiveRecord;
use yii\helpers\HtmlPurifier;
use yii\behaviors\TimestampBehavior;

/**
 * @property $id
 * @property $list_id
 * @property $description
 * @property $finished_at
 * @property $created_at
 * @property $updated_at
 * @property $deleted
 * @property $date
 */
class TaskModel extends ActiveRecord
{

    public static function tableName()
    {
        return 'tasks';
    }

    public function behaviors()
    {
        return [
            TimestampBehavior::className(),
        ];
    }

    public function rules()
    {
        return [
            [['list_id', 'description'], 'required'],
            //['description', 'filter', 'filter' => function($value){ return HtmlPurifier::process($value); }],
            ['list_id', 'exist', 'targetClass' => ListModel::className(), 'targetAttribute' => 'id']
        ];
    }

    public function init()
    {
        parent::init();
        $this->on(self::EVENT_BEFORE_INSERT, function(){
            $this->deleted = 0;
            $this->finished_at = 0;
        });
    }

    public function getDate()
    {
        return date('d.m.Y в H:i:s', $this->created_at);
    }

}