
Работа с REST API
============
Выполнил: Касьянов Кирилл, zions@bk.ru


Писал на фреймворке Yii2

Документация по фреймворку:

https://github.com/yiisoft/yii2/tree/master/docs/guide-ru

Установка проекта
--
0. Создать базу данных и экспортировать данные о таблицах

`!!! Дамп базы занных находится в файле dump.sql`

1. Склонировать репозиторий

2. Необходимо установить дополнение к композеру для управления bower зависимости:
 
`composer global require "fxp/composer-asset-plugin:^1.3.1"`

3. Установить зависимоти
  
`composer install`

Внимание! Потребуется git-token. Вот заранее сгенерированный: `60ff90ee728df12456ad80078b272c99b2a4e9ca`

4. Настроить подключение к базе данных в файле:

`config/db.php`

Если что, по установке Yii2 информация тут:

https://github.com/yiisoft/yii2/blob/master/docs/guide-ru/start-installation.md

**Внимание!** Веб доступная дирректория находится в папке /web

Запросы к API
==
**Все запросы (кроме создания нового пользователя) требуют, чтобы в теле запроса был передан JSON документ,
с обязательными ключами `user_id` и `auth_key`**

На частоту запросов установлено ограничение - по-умолчанию не более 30 запросов в минуту.
Значение можно изменить в базе данных для конкретного пользователя (поле requests_limit).
Значение 0 будет означать отсутствие ограничения.

Создание пользователя
--
`PUT /web/user`


Удаление пользователя
--
`DELETE /web/user`

Получение информации о пользователе
--
POST /web/user

**Чтобы получить дополнительную информацию** о пользователе,
необходимо в JSON документ передать ключ needle_params и перечислить
в нем список из возможных следующих ключей:

`last_request_datetime` - дата и время последнего запроса
в формате d.m.Y H:i:s (текущий запрос не учитывается).

`last_request_timestamp` - timestamp последнего запроса. сделал дополнительно.

`requests_count_per_day` - общее кол-во дней, когда были запросы.
Запрос кешируется на сутки. Поскольку эта информация не изменяется в течении
суток.

`requests_count_periodical` - кол-во дней, когда запросы шли ежедневно
(более 1 дня, подряд). Как понял задание. Запрос кешируется на сутки. 
Поскольку эта информация не изменяется в течении суток.

Сейчас реализовано кеширование на файлах.
Для подключения кеширования MemCache необходимо
открыть файл конфигурации `/config/web.php`, где примерный кусок 
конфигурации оставил закомментированным.

**Чтобы получть данные пользователя**, необходимо в JSON документ передать 
ключ needle_data и перечислить в нем список необходимых ключей.

Значение ключей, которых нет в базе данных, будут установлены как `null`.

`Пример тела запроса:`
```
{
    "user_id": 1,
    "auth_key": "65SdNz8D-lXy-7zf7tzix-AyPwDscLxGmwbpbtB7IGYB2-SbItrNxvO-yJ1_42-X",
    "needle_params": [
        "last_request_datetime",
        "last_request_timestamp",
        "requests_count_per_day",
        "requests_count_periodical"
    ],
    "needle_data": [
        "key1",
        "key2",
        "key3"
    ]
}
```

Добавление и изменение информации
--

POST /web/user/data

Что бы добавить или изменить данные пользователя,
необходимо в JSON документе учтановить ключ `data`, а значение - объект,
вида "ключ" => "значение".

`Пример тела запроса:`
```
{
    "user_id": 1,
    "auth_key": "65SdNz8D-lXy-7zf7tzix-AyPwDscLxGmwbpbtB7IGYB2-SbItrNxvO-yJ1_42-X",
    "data": {
        "key1": "value1",
        "key2": "value2",
        "key3": "value3"
    }
}
```


